function AsyncLoop(initValue, length, batchCount, interval, f) {
	this.initValue = initValue
	this.length = length
	this.batchCount = batchCount
	this.interval = interval
	this.f = f
	this.curIndex = 0
	this.stopped = false
}
AsyncLoop.prototype.runBatch = function() {
	if(this.cancelFunction) {
		this.cancelFunction()
		this.stopped = true
		return
	}
	
	for(var i = 0; i < this.batchCount && this.curIndex < this.length; i++) {
		this.f(this.curIndex++)
	}
	if(this.curIndex < this.length) {
		this.run()
	} else {
		this.finished()
		this.stopped = true
	}
}
AsyncLoop.prototype.run = function() {
	var oThis = this
	var batch = function() {
		oThis.runBatch()
	}
	setTimeout(batch, this.interval)
}
AsyncLoop.prototype.cancelAndExecute = function(f) {
	this.cancelFunction = f
}
AsyncLoop.prototype.finished = function() {}