function PopupAddressBook(addrArray, pRowNormalId, pRowEditId, pRowSelectId, addrTableIdPrefix, isGroup) {
	this.addrArray = addrArray
	this._removeLastEmptyElement(this.addrArray)

	this.addrArrays = new Array()
	this.addrTables = new Array()
	this.addrJTables = new Array()
	this.pRowNormal = document.getElementById(pRowNormalId)
	this.pRowEdit = document.getElementById(pRowEditId)
	this.pRowSelect = document.getElementById(pRowSelectId)
	this.addrTableIdPrefix = addrTableIdPrefix
	this.curTable = -1
	this._isGroup = isGroup
	
	this.filters = [
		function(str) {return true},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < 'ī'},
		function(str) {return str.length > 0 && 'ī' <= str.charAt(0) && str.charAt(0) < 'Ÿ'},
		function(str) {return str.length > 0 && 'Ÿ' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) < ''},
		function(str) {return str.length > 0 && '' <= str.charAt(0) && str.charAt(0) <= 'R'},
		function(str) {return str.length > 0 && (('A' <= str.charAt(0) && str.charAt(0) < 'Z') || ('a' <= str.charAt(0) && str.charAt(0) < 'z'))},
		function(str) {return str.length > 0 && '0' <= str.charAt(0) && str.charAt(0) < '9'}
	]
}
PopupAddressBook.prototype.insertNewItem = function(name, email, cphone, homePhone, officePhone) {
	var value = {name:name, email:email, cphone:cphone, homePhone:homePhone, officePhone:officePhone}
	this.addrArray.push(value)
	for(var i = 0; i < this.filters.length; i++) {
		if(this.filters[i](name) && this.addrJTables[i]) {
			this.addrJTables[i].addRow(this.selectRow(value))
		}
	}
}
PopupAddressBook.prototype.sort = function(columnIndex) {
	this.addrJTables[this.curTable].toggleSort(columnIndex)
}
PopupAddressBook.prototype.showTable = function(index, selectAll) {
	if(this.curTable != -1) {
		this.addrTables[this.curTable].style.display = "none"
	}
	if(!this.addrArrays[index]) {
		this.addrTables[index] = document.getElementById(this.addrTableIdPrefix + index)
		this.addrTables[index].style.display = "block"
		this.addrArrays[index] = this.filterAddrArrays(index)
		this.addrJTables[index] = new JaniaTable(this.addrTables[index], this.pRowNormal, this.pRowEdit, this.pRowSelect)
		if(!this._isGroup) {
			this.addrJTables[index].setMaxDisplayLength([12, 0])
		} else {
			this.addrJTables[index].setMaxDisplayLength([0, 12, 0])
		}

		var oThis = this
		var f = function(i) {
			oThis.addrJTables[index].addRow(oThis.selectRow(oThis.addrArrays[index][i]))
		}

		var asyncLoop = new AsyncLoop(0, this.addrArrays[index].length, 50, 10, f)
		if(selectAll) {
			asyncLoop.finished = function() {
				oThis.addrJTables[index]._ms.selectAll()
			}
		}
		asyncLoop.run()

		//this.addrJTables[index].setInitialSortStatus(0, true)
		//this.addrJTables[index].sort(1, true)
		this.addrTables[index].style.display = "block"
		this.curTable = index
	} else {
		//this.addrJTables[index].setInitialSortStatus(0, true)
		//this.addrJTables[index].sort(1, true)
		this.addrTables[index].style.display = "block"
		if(selectAll) {
			this.addrJTables[index]._ms.selectAll()
		}
		this.curTable = index
	}
}
PopupAddressBook.prototype.isSelectedAll = function() {
	return (this.curTable == 0) && this.addrJTables[this.curTable]._ms.isSelectedAll()
}
PopupAddressBook.prototype.search = function(key, value, index) {
	if(this.curTable != -1) {
		this.addrTables[this.curTable].style.display = "none"
	}
	if(this.addrArrays[index]) {
		this.addrJTables[index].clearAll()
	}
	this.addrTables[index] = document.getElementById(this.addrTableIdPrefix + index)
	this.addrTables[index].style.display = "block"
	this.addrArrays[index] = this.searchAddrArrays(key, value)
	this.addrJTables[index] = new JaniaTable(this.addrTables[index], this.pRowNormal, this.pRowEdit, this.pRowSelect)
	if(!this._isGroup) {
		this.addrJTables[index].setMaxDisplayLength([12, 0])
	} else {
		this.addrJTables[index].setMaxDisplayLength([0, 12, 0])
	}
	
	var oThis = this
	var f = function(i) {
		oThis.addrJTables[index].addRow(oThis.selectRow(oThis.addrArrays[index][i]))
	}
	var asyncLoop = new AsyncLoop(0, this.addrArrays[index].length, 50, 10, f)
	asyncLoop.run()

	this.addrJTables[index].setInitialSortStatus(0, true)
	this.curTable = index
}
PopupAddressBook.prototype.selectRow = function(value) {
	return [value.name, value.email]
}
PopupAddressBook.prototype.filterAddrArrays = function(index) {
	var result = new Array()
	var filter = this.filters[index]

	for(var i = 0; i < this.addrArray.length; i++) {
		if(filter(this.addrArray[i].name)) result.push(this.addrArray[i])
	}
	return result
}
PopupAddressBook.prototype.searchAddrArrays = function(key, value) {
	var result = new Array()
	for(var i = 0; i < this.addrArray.length; i++) {
		if(this.addrArray[i][key].indexOf(value) != -1) result.push(this.addrArray[i])
	}
	return result
}
PopupAddressBook.prototype.addTo = function(selectId) {
	var rows = this.addrJTables[this.curTable].getSelectedRows()
	if(rows.length < 1) {
		return
	}
	var selectElement = document.getElementById(selectId)
	for(var i = 0; i < rows.length; i++) {
		var value = this.extractMailToValue(rows[i]._attachedData)
		var optionElement = document.createElement("option")
		var label = document.createTextNode(value)
		optionElement.value = value
		optionElement._registeredAddr = true
		if(!this.hasItem(selectElement, value)) {
			selectElement.appendChild(optionElement)
			optionElement.appendChild(label)
		}
	}
}
PopupAddressBook.prototype.addGroupTo = function(selectId, name) {
	var selectElement = document.getElementById(selectId)
	var optionElement = document.createElement("option")
	var label = document.createTextNode(name)
	optionElement.value = name
	optionElement._registeredAddr = true
	if(!this.hasItem(selectElement, name)) {
		selectElement.appendChild(optionElement)
		optionElement.appendChild(label)
	}
}
PopupAddressBook.prototype.hasItem = function(selectElement, value) {
	for(var i = 0; i < selectElement.length; i++) {
		if(selectElement.options[i].value == value)
			return true;
	}
	return false;
}
PopupAddressBook.prototype.extractMailToValue = function(data) {
	return data[0] + " " + data[1]
}
PopupAddressBook.prototype.removeFrom = function(selectId) {
	var removeCnt = 0
	var selectElement = document.getElementById(selectId)
	for(var i = 0; i < selectElement.options.length;) {
		if(selectElement.options[i].selected) {
			selectElement.remove(i)
			removeCnt++
		} else {
			i++
		}
	}
	if(removeCnt == 0)
		alert(' ּҸ ּ.')
}
PopupAddressBook.prototype._removeLastEmptyElement = function(array) {
	if(array.length > 0 && !array[array.length - 1]) array.pop()
}